package  
{
	import bigal.AgalBase;
	import bigal.models.tree.Grave;
	import bigal.models.tree.Ground;
	import bigal.models.tree.Pumpkin;
	import bigal.models.tree.Tree;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Vector3D;
	import flash.utils.getTimer;
	
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class Main extends AgalBase 
	{
		private var pumpkin:Pumpkin;
		private var grave:Grave;
		
		private var targetRotationY:Number 	= 0;
		private var cameraDistance:Number 	= 0;
		private var tmpRotationY:Number 	= 0;
		
		public function Main() 
		{
			
			super( 0, stage.stageWidth, stage.stageHeight );
			
		}
		
		override public function init():void
		{
			
			register( new Ground() );
			register( new Tree() );
			
			register( pumpkin = new Pumpkin() );
			pumpkin.x = -33;
			pumpkin.y = 13;
			pumpkin.z = -32;
			
			register( grave = new Grave() );
			grave.x = 20;
			grave.y = 22.3;
			grave.z = -28;
			
			cameraDistance = -200;
			
			addEventListener( Event.ENTER_FRAME, onEnterFrame );
			
			stage.addEventListener( MouseEvent.MOUSE_WHEEL, onMouseHandler );
			stage.addEventListener( MouseEvent.MOUSE_DOWN, onMouseHandler );
			stage.addEventListener( MouseEvent.MOUSE_UP, onMouseHandler );
			
			text.htmlText = "3D model by <u><a href=\"http://www.lonewolf3d.com/\">LONEWOLF</a></u>\n"	+
							"found on <u><a href=\"http://www.ShareCG.com/v/31915/view/5/3D-Model/Mtree-|-old-model-|\">SHARECG</a></u>";
			
		}
		private function onEnterFrame(e:Event):void 
		{
			
			cameraDistance = -110 - ( .5 + Math.sin( getTimer() * 0.0001 ) * .5 ) * 100;
			
			camera.y = Math.abs( camera.z ) * .1;
			camera.z += ( cameraDistance - camera.z ) * .1;
			camera.lookat( new Vector3D( 0, 110-Math.abs( camera.z ) *.15) );
			
			world.rotationY += ( targetRotationY - world.rotationY ) * .1;
			
			render();
			
		}
		
		private function onMouseHandler(e:MouseEvent):void 
		{
			if ( e.target != stage ) return;
			if ( e.type == MouseEvent.MOUSE_DOWN )
			{
				targetRotationY += ( mouseX > viewportWidth * .5 ) ? 45 : -45;
			}
		}
		
	}

}