package bigal 
{
	import flash.geom.Matrix3D;
	
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class Lens extends Matrix3D 
	{
		
		private var _fov:Number = 60;
		private var _aspectRatio:Number = ( 16 / 9 );
		private var _near:Number = 1;
		private var _far:Number = 500;
		
		
		public function Lens( fov:Number = 60, aspectRatio:Number = 1, near:Number = 1, far:Number = 1000 ) 
		{
			super();
			
			_fov = fov;
			_aspectRatio = aspectRatio;
			_near = near;
			_far = far;
			reset();
			
		}
		
		public function get fov():Number 
		{
			return _fov;
		}
		
		public function set fov(value:Number):void 
		{
			_fov = value;
			reset();
		}
		
		public function get aspectRatio():Number 
		{
			return _aspectRatio;
		}
		
		public function set aspectRatio(value:Number):void 
		{
			_aspectRatio = value;
			reset();
		}
		
		public function get near():Number 
		{
			return _near;
		}
		
		public function set near(value:Number):void 
		{
			_near = value;
			reset();
		}
		
		public function get far():Number 
		{
			return _far;
		}
		
		public function set far(value:Number):void 
		{
			_far = value;
			reset();
		}
		
		
		public function reset():void
		{
			identity();
			
			var y2:Number = near * Math.tan(fov * Math.PI / 360);
			var y1:Number = -y2;
			var x1:Number = y1 * aspectRatio;
			var x2:Number = y2 * aspectRatio;

			var a:Number = 2 * near / (x2 - x1);
			var b:Number = 2 * near / (y2 - y1);
			var c:Number = (x2 + x1) / (x2 - x1);
			var d:Number = (y2 + y1) / (y2 - y1);
			var q:Number = -(far + near) / (far - near);
			var qn:Number = -2 * (far * near) / (far - near);

			rawData = Vector.<Number>(	[
										-a, 0, 0, 0,
										0, b, 0, 0,
										c, d, q, -1,
										0, 0, qn, 0
										]);
			
		}
		
	}

}