package bigal.utils 
{
	import flash.display3D.Context3D;
	import flash.display3D.Context3DBlendFactor;
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class AgalBlendMode 
	{
		
		
		static public const ADD:String 				= "add";
		static public const ALPHA:String 			= "alpha";
		static public const HARDLIGHT:String 		= "hardlight";
		static public const MULTIPLY:String 		= "multiply";
		static public const NEGATIVE:String 		= "negative";
		static public const NORMAL:String 			= "normal";
		static public const SCREEN:String 			= "screen";
		static public const SHIMMERING:String 		= "shimmering";
		static public const CUSTOM:String 			= "custom";
		
		
		static public function apply( context:Context3D, value:String ) : void
		{
			//http://www.andersriggelsen.dk/glblendfunc.php
			switch( value )
			{
			
			//context.setBlendFactors( Context3DBlendFactor.ONE_MINUS_DESTINATION_COLOR, Context3DBlendFactor.ONE_MINUS_SOURCE_COLOR );//négatif sur les overlays clair, alpha ailleurs
			
			//duh
			//context.setBlendFactors( Context3DBlendFactor.SOURCE_COLOR, Context3DBlendFactor.ONE_MINUS_DESTINATION_COLOR );//négatif sur les overlays clair, alpha ailleurs
				
					
				case ADD:
					context.setBlendFactors( Context3DBlendFactor.ONE, Context3DBlendFactor.ONE );//add
					break;
					
				case ALPHA:
					context.setBlendFactors( Context3DBlendFactor.SOURCE_ALPHA, Context3DBlendFactor.ONE_MINUS_SOURCE_ALPHA );//alpha
					break;
					
				case HARDLIGHT:
					context.setBlendFactors( Context3DBlendFactor.SOURCE_ALPHA, Context3DBlendFactor.DESTINATION_COLOR );//hardlight
					break;
					
				case MULTIPLY:
					context.setBlendFactors( Context3DBlendFactor.DESTINATION_COLOR, Context3DBlendFactor.ZERO );//multiply
					break;
					
				case NEGATIVE:
					context.setBlendFactors( Context3DBlendFactor.ZERO, Context3DBlendFactor.ONE_MINUS_SOURCE_COLOR );//negatif
					break;
				
				case NORMAL:
					context.setBlendFactors( Context3DBlendFactor.ONE, Context3DBlendFactor.ZERO );//none
					break;
					
				case SCREEN:
					context.setBlendFactors( Context3DBlendFactor.ONE, Context3DBlendFactor.ONE_MINUS_SOURCE_COLOR );//screen
					break;
				
				case SHIMMERING:
					context.setBlendFactors( Context3DBlendFactor.ONE, Context3DBlendFactor.SOURCE_COLOR );//additif sur le clair, soustractif sur le foncé
					break;
					
				case CUSTOM:
					context.setBlendFactors( Context3DBlendFactor.ONE_MINUS_SOURCE_COLOR, Context3DBlendFactor.ONE_MINUS_DESTINATION_ALPHA );//add
					break;
					
			}
			
		}
		
		
	}

}